#include "BuildingData.h"

BuildingData::BuildingData(BWAPI::Unit * u) : 
	UnitData(u),
	state(BuildingState::None),
	tposition(u->getTilePosition()),
	hp(u->getHitPoints())
{
	tsize[0] = getType().tileWidth();
	tsize[1] = getType().tileHeight();
}

BuildingData::BuildingData() :
	UnitData()
{
}

BuildingData::~BuildingData(void){}


void BuildingData::update(){
	/*std::ofstream bout("build.txt", std::ios_base::binary | std::ios_base::out | std::ios_base::trunc);
	if (!bout) {
		std::cout << "***error  o̓t@CJ܂\n";
		exit(1);
	}*/
	if(logging_flag) out << getType().c_str() << std::endl;
	if(logging_flag) out << "8-1" << std::endl;
	unit_update();
	hp = getUnit()->getHitPoints();
	if(logging_flag) out << "8-2" << std::endl;
	//ResourceDepot̎󂯂邩ǂc
	if(getType().isResourceDepot()){
		for(int i = tposition.x() - 1; i < tposition.x() + tsize[0] + 1; i++){
			for(int j = tposition.y() - 1; j < tposition.y() + tsize[1] + 1; j++){
				mapdata.setBuildableMap(i,j,false);
				//BWAPI::Broodwar->drawDotMap(i*TILE_SIZE, j*TILE_SIZE, BWAPI::Colors::Red);
			}
		}
	}else{
		for(int i = tposition.x(); i < tposition.x() + tsize[0]; i++){
			for(int j = tposition.y(); j < tposition.y() + tsize[1]; j++){
				mapdata.setBuildableMap(i,j,false);
				//BWAPI::Broodwar->drawDotMap(i*TILE_SIZE, j*TILE_SIZE, BWAPI::Colors::Red);
			}
		}
	}
	if(logging_flag) out << "8-3" << std::endl;

	//BWAPI::Broodwar->drawTextMap(getPosition().x(), getPosition().y() -20, "(%d,%d) %d, %d", tposition.x(), tposition.y(), tsize[0], tsize[1]);

	//building state update
	if(state == BuildingState::Completed){
		state = BuildingState::None;
	}else if(state == BuildingState::Constructing && getUnit()->isCompleted()){
		state = BuildingState::Completed;
		if(getType().isResourceDepot()){
			mapdata.setMybases(BWTA::getRegion(getPosition())); //hatcheryȂΐVnȂ
		}
	}else if(state == BuildingState::Execute && !(getUnit()->isTraining() || getUnit()->isResearching() || getUnit()->isUpgrading())){
		state = BuildingState::Completed;
	}else if(state == BuildingState::None && getUnit()->isConstructing()){
		state = BuildingState::Constructing;
	}else if(state == BuildingState::None && (getUnit()->isTraining() || getUnit()->isResearching() || getUnit()->isUpgrading())){
		state = BuildingState::Execute;
	}/*else if(state == BuildingState::None && getType().isResourceDepot() && getUnit()->isCompleted()){
		mapdata.setMybases(BWTA::getRegion(getPosition())); //hatcheryȂΐVnȂ
	}*/
	if(logging_flag) out << "8-4" << std::endl;
}

void  BuildingData::eupdate(){
	if(getUnit()->isVisible()){
		unit_update();
		hp = getUnit()->getHitPoints();
	}
}

char *  BuildingData::getStateChar() const
{
	if(state == 0) return "None";
	else if(state == 1) return "Execute";
	else if(state == 2) return "Constructing";
	else if(state == 3) return "Completed";
	else return "????";
}

int  BuildingData::getState() const
{ return state;}

int  BuildingData::getHp() const
{ return hp;}

BWAPI::TilePosition BuildingData::getTposition() const{
	return tposition;
}

void  BuildingData::setState(const int &i){
	if(i >= BuildingState::Max) return;
	state = i;
	return;
}