#include "CimexModule.h"

void CimexModule::onStart()
{
	BWAPI::Broodwar->setLocalSpeed(0);
	BWAPI::Broodwar->enableFlag(BWAPI::Flag::UserInput);
	BWTA::readMap();
	BWTA::analyze();
	BWAPI::Broodwar->setCommandOptimizationLevel(3);
	if(logging_flag2){
		out2.open("test2.txt", std::ios_base::binary | std::ios_base::out | std::ios_base::trunc);
		assert(out2);
		out3.open("test3.txt", std::ios_base::binary | std::ios_base::out | std::ios_base::trunc);
		assert(out3);
	}
	out4.open("test4.txt", std::ios_base::binary | std::ios_base::out | std::ios_base::trunc);



	if(logging_flag){
		out.open("test.txt", std::ios_base::binary | std::ios_base::out | std::ios_base::trunc);
		assert(out);
	}

	std::string enemy_name = BWAPI::Broodwar->enemy()->getName().c_str();
	std::string gbo_out_str = "bwapi-data/write/gbo_" + enemy_name + ".txt";
	std::string gbo_in_str = "bwapi-data/read/gbo_" + enemy_name + ".txt";

	gbo_out.open(gbo_out_str.c_str(), std::ios_base::binary | std::ios_base::out | std::ios_base::trunc);
	assert(gbo_out);
	gbo_in.open(gbo_in_str.c_str());
	if(gbo_in == NULL){
		strategy_num = 0;
		winning_streak = 0;
	}else{
		std::string instr;
		gbo_in >> instr;
		strategy_num = std::atoi(instr.c_str());
		gbo_in >> instr;
		winning_streak = std::atoi(instr.c_str());
	}

	buildOrderManager.init();

	mapdata.init();

}

void CimexModule::onFrame(){
	//if(BWAPI::Broodwar->getFrameCount() == 5) BWAPI::Broodwar->sendText("/cheats\n");
	//BWAPI::Broodwar->drawCircleMap(mapdata.getWaitPosition().x(), mapdata.getWaitPosition().y(), 20, BWAPI::Colors::Red);
	/*if(logging_flag2){
		out2 << BWAPI::Broodwar->getFrameCount() << " ";
		out3 << BWAPI::Broodwar->getFrameCount() << " ";
		out2 << "m:" << BWAPI::Broodwar->self()->minerals() << " s:" << BWAPI::Broodwar->self()->supplyUsed() << "/" <<  BWAPI::Broodwar->self()->supplyTotal() << " ";
		int drone = 0,
			larva = 0,
			egg = 0,
			overload = 0,
			zergling = 0,
			hatchery = 0,
			pool = 0;
		BOOST_FOREACH(BWAPI::Unit* unit, BWAPI::Broodwar->self()->getUnits()){
			BWAPI::UnitType type = unit->getType();
			if(type == BWAPI::UnitTypes::Zerg_Drone) drone++;
			else if(type == BWAPI::UnitTypes::Zerg_Larva) larva++;
			else if(type == BWAPI::UnitTypes::Zerg_Egg){
				out2 << "[" << unit->getBuildType().c_str() << "]";
				egg++;
			}else if(type == BWAPI::UnitTypes::Zerg_Overlord) overload++;
			else if(type == BWAPI::UnitTypes::Zerg_Zergling) zergling++;
			else if(type == BWAPI::UnitTypes::Zerg_Hatchery) hatchery++;
			else if(type == BWAPI::UnitTypes::Zerg_Spawning_Pool) pool++;
		}
		out2 << "d:" << drone << " ";
		out2 << "l:" << larva << " ";
		out2 << "e:" << egg << " ";
		out2 << "o:" << overload << " ";
		out2 << "z:" << zergling << " ";
		out2 << "h:" << hatchery << " ";
		out2 << "p:" << pool << " ";
	}*/

	/*int timey = 50;
	all_timer.startTime();
	exe_timer.startTime();*/

	
	if(logging_flag) out << "1,"<< std::endl;
	playerdata.update(); //~lȂǂ̍XV

	//exe_timer.exeTime(&max_player);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "InitUpdate1");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_player);
	//timey += 10;

	//exe_timer.startTime();

	if(logging_flag) out << "2,"<< std::endl;
	mapdata.update(); //}bv̍XV


	//exe_timer.exeTime(&max_map);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "InitUpdate2");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_map);
	//timey += 10;

	

	//Gjbg̍폜//////////////////////////////////////////////////////////////
	exe_timer.startTime();
	
	if(logging_flag) out << "3,"<< std::endl;
	enemyDataManager.removeUnit();

	//exe_timer.exeTime(&max_erase);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "Erase");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_erase);
	//timey += 10;
	//exe_timer.startTime();


	//Gjbg̒ǉ/////////////////////////////////////////////////////////////////////////////////
	if(logging_flag) out << "5,"<< std::endl;
	
	enemyDataManager.createUnit();

	//exe_timer.exeTime(&max_add);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "Add");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_add);
	//timey += 10;


	//Rjbg̍XV//////////////////////////////////////////////////////////////////////
	//exe_timer.startTime();
	if(logging_flag) out << "6,"<< std::endl;
	if(!workers.empty()) 
		BOOST_FOREACH(WorkerData &w, workers) w.update();
	//exe_timer.exeTime(&max_wupdate);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "MyWorkerUpdate");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_wupdate);
	//timey += 10;

	//exe_timer.startTime();
	if(logging_flag) out << "7,"<< std::endl;
	if(!attackers.empty())
		BOOST_FOREACH(AttackerData &a, attackers) a.update();
	//exe_timer.exeTime(&max_aupdate);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "MyAttackerUpdate");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_aupdate);
	//timey += 10;

	//exe_timer.startTime();
	if(logging_flag) out << "8," << std::endl;
	if(!buildings.empty())
		BOOST_FOREACH(BuildingData &b, buildings) b.update();
	//exe_timer.exeTime(&max_bupdate);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "MyBuildingUpdate");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_bupdate);
	//timey += 10;

	//exe_timer.startTime();
	if(logging_flag) out << "9,"<< std::endl;
	if(!resources.empty())
		BOOST_FOREACH(ResourceData &r, resources) r.update();
	if(logging_flag) out << "9.5,"<< std::endl;
	resourceManager.update();
	//exe_timer.exeTime(&max_rupdate);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "MyResourceUpdate");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_rupdate);
	//timey += 10;

	//exe_timer.startTime();
	if(logging_flag) out << "10,"<< std::endl;
	if(!larvas.empty())
		BOOST_FOREACH(LarvaData &l, larvas) l.update();
	//exe_timer.exeTime(&max_lupdate);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "MyLarvaUpdate");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_lupdate);
	//timey += 10;

	//exe_timer.startTime();
	if(logging_flag) out << "11,"<< std::endl;
	if(!others.empty())
		BOOST_FOREACH(OtherUnitData &o, others) o.update();
	//exe_timer.exeTime(&max_oupdate);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "MyOtherUpdate");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_oupdate);
	//timey += 10;



	//Gjbg̍XV//////////////////////////////////////////////////////////////////////
	//exe_timer.startTime();
	if(logging_flag) out << "12,"<< std::endl;
	BOOST_FOREACH(WorkerData &w, eworkers) w.eupdate();
	//exe_timer.exeTime(&max_ewupdate);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "EnemyWorkerUpdate");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_ewupdate);
	//timey += 10;

	//exe_timer.startTime();
	if(logging_flag) out << "13,"<< std::endl;
	//BuildOrderData::enemy_attackers_hp = 0;
	BOOST_FOREACH(AttackerData &a, eattackers) a.eupdate();
	//exe_timer.exeTime(&max_eaupdate);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "EnemyAttackerUpdate");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_eaupdate);
	//timey += 10;

	//exe_timer.startTime();
	if(logging_flag) out << "14,"<< std::endl;
	BOOST_FOREACH(BuildingData &b, ebuildings) b.eupdate();
	//exe_timer.exeTime(&max_ebupdate);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "EnemyBuildingUpdate");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_ebupdate);
	//timey += 10;

	//exe_timer.startTime();
	if(logging_flag) out << "15,"<< std::endl;
	BOOST_FOREACH(OtherUnitData &o, eothers) o.eupdate();
	//exe_timer.exeTime(&max_eoupdate);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "EnemyOtherUpdate");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_eoupdate);
	//timey += 10;

	//Ԃɉworker𓮂//////////////////////////////////////////////////////////////////////////

	//exe_timer.startTime();
	if(logging_flag) out << "16," << &workers << " " << std::endl;

	buildOrderManager.constructionManager.workerManager.update();

	//exe_timer.exeTime(&max_wmanage);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "WorkerManage");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_wmanage);
	//timey += 10;


	//ԂɉAttacker𓮂//////////////////////////////////////////////////////////////////////////////////////////////
	//exe_timer.startTime();
	
	if(logging_flag) out << "17," << &attackers << " " << std::endl;

	buildOrderManager.productionManager.attackerManager.update();

	//exe_timer.exeTime(&max_amanage);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "AttackerManage");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_amanage);
	//timey += 10;

	//ԂɉOtherUnit𓮂//////////////////////////////////////////////////////////////////////////////////////////////
	//exe_timer.startTime();

	if(logging_flag) out << "18," << &others << " " << std::endl;
	
	otherUnitManager.update();

	//exe_timer.exeTime(&max_omanage);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "OthersManage");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_omanage);
	//timey += 10;

	//ԂɉBuilding𓮂//////////////////////////////////////////////////////////////////////////////////////////////
	//exe_timer.startTime();

	if(logging_flag) out << "19," << &buildings << " " << std::endl;
	buildOrderManager.constructionManager.buildingManager.update();

	//exe_timer.exeTime(&max_bmanage);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "BuildingManage");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_bmanage);
	//timey += 10;

	//jbgY///////////////////////////////////////////////////////////////////////////////////////////
	//exe_timer.startTime();

	if(logging_flag) out << "20,"<< std::endl;
	if(logging_flag) out << larvas.size() << std::endl;

	buildOrderManager.update();

	//exe_timer.exeTime(&max_produce);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "Produce");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_produce);
	//timey += 10;


	//fobO////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	Debug debug;
	//exe_timer.startTime();
	if(logging_flag) out << "21,"<< std::endl;
	//debug.update();
	//exe_timer.exeTime(&max_debug);

	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "Debug");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_debug);
	//timey += 10;

	//all_timer.exeTime(&max_all);
	//BWAPI::Broodwar->drawTextScreen(timex1, timey, "All");
	//BWAPI::Broodwar->drawTextScreen(timex2, timey, "%4.1fms", max_all);
	/*if(logging_flag2){
		out2 << BWAPI::Broodwar->getLatency() << ":" << BWAPI::Broodwar->getLatencyFrames();
		int order_num = 0;
		BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->self()->getUnits()){
			if(u->getOrder() == BWAPI::Orders::Stop
				|| u->getOrder() == BWAPI::Orders::None
				|| u->getOrder() == BWAPI::Orders::Unknown) continue;
			order_num++;
		}
		/*BOOST_FOREACH(BWAPI::Event e, BWAPI::Broodwar->getEvents()){
			out3 << e.getType().c_str();
		}*/
		/*out2 << std::endl;
	}*/
	if(logging_flag) out << "success" << std::endl;
}

void CimexModule::onEnd(bool isWinner){

	if(isWinner){ //if win
		winning_streak++;
		gbo_out << strategy_num << std::endl;
		gbo_out << winning_streak << std::endl;
	}else{ //if lose
		if(winning_streak >= 1){
			winning_streak = 0;
			gbo_out << strategy_num << std::endl;
			gbo_out << winning_streak << std::endl;
		}else{
			winning_streak = 0;
			strategy_num++;
			gbo_out << strategy_num << std::endl;
			gbo_out << winning_streak << std::endl;
		}
	}

	if(logging_flag) out << "End" << std::endl;
}


void CimexModule::onUnitMorph(BWAPI::Unit* unit){
	if(logging_flag) out << "morph " << unit->getType().getName().c_str() << std::endl;
	BOOST_FOREACH(LarvaData l, larvas){
		if(l.getId() != unit->getID()) continue;
		l.setIsMorphing(true);
	}
	//if(logging_flag2) out2 << "$$" << unit->getID() << "$$";

	//RMorph
	if(unit->getPlayer() == BWAPI::Broodwar->self() && unit->getType() != BWAPI::UnitTypes::Zerg_Egg){
		//MorphÕjbg͏ Morph̃jbg͑}
		if(unit->getType().isBuilding()){
			//폜 Worker HiveȂǂ͌ŏꍇI
			if(unit->getType() == BWAPI::UnitTypes::Zerg_Sunken_Colony || unit->getType() == BWAPI::UnitTypes::Zerg_Spore_Colony || unit->getType() == BWAPI::UnitTypes::Zerg_Lair || unit->getType() == BWAPI::UnitTypes::Zerg_Hive){
				buildOrderManager.constructionManager.buildingManager.removeBuilding(unit);
			}else buildOrderManager.constructionManager.workerManager.removeWorker(unit);
			//}
			if(unit->getType().isRefinery()){
				//resourceManager.createResource(unit);
			}else {
				buildOrderManager.constructionManager.buildingManager.createBuilding(unit);
			}

		}else{
			if(unit->getType() == BWAPI::UnitTypes::Zerg_Lurker || unit->getType() == BWAPI::UnitTypes::Zerg_Devourer || unit->getType() == BWAPI::UnitTypes::Zerg_Guardian){
				buildOrderManager.productionManager.attackerManager.removeAttacker(unit);
				buildOrderManager.productionManager.attackerManager.createAttacker(unit);
			}else{
				//Larva Egg܂ŕێ Unit͂قƂǂȂ̂ł̑xXg
				buildOrderManager.productionManager.larvaManager.removeLarva(unit);

				//}
				if(unit->getType().isWorker()){
					buildOrderManager.constructionManager.workerManager.createWorker(unit);
				}else if(unit->getType() == BWAPI::UnitTypes::Zerg_Overlord){
					otherUnitManager.createOtherUnit(unit);
				}else{
					if(!unit->getType().isResourceContainer()) buildOrderManager.productionManager.attackerManager.createAttacker(unit);
				}
			}
		}
	}
}

void CimexModule::onUnitCreate(BWAPI::Unit* unit){
	if(logging_flag) out << "create " << unit->getType().getName().c_str() << std::endl;
	//if(unit->getType() == BWAPI::UnitTypes::Spell_Dark_Swarm) BWAPI::Broodwar->setScreenPosition(unit->getPosition().x() - 300, unit->getPosition().y() - 200);//out4 << "create " << unit->getType().getName().c_str() << " " << unit->getPlayer()->getName().c_str() << std::endl;
	//RCreate
	if(unit->getType().isResourceContainer() && unit->getPlayer() != BWAPI::Broodwar->enemy() && !unit->getType().isRefinery())
		resourceManager.createResource(unit);

	if (unit->getPlayer() == BWAPI::Broodwar->self()){
		if(unit->getType().isWorker()){
			buildOrderManager.constructionManager.workerManager.createWorker(unit);
		}else if(unit->getType() == BWAPI::UnitTypes::Zerg_Overlord){
			otherUnitManager.createOtherUnit(unit);
		}else if(unit->getType().isBuilding()){
			buildOrderManager.constructionManager.buildingManager.createBuilding(unit);
		}else if(unit->getType() == BWAPI::UnitTypes::Zerg_Larva){
			buildOrderManager.productionManager.larvaManager.createLarva(unit);
		}else{
			if(!unit->getType().isResourceContainer()) buildOrderManager.productionManager.attackerManager.createAttacker(unit);
		}
	}
}

void CimexModule::onUnitDestroy(BWAPI::Unit* unit){
	if(logging_flag) out << "destroy " << unit->getType().getName().c_str() << std::endl;
	//if(unit->getType() == BWAPI::UnitTypes::Spell_Dark_Swarm) out4 << "destroy " << unit->getType().getName().c_str() << " " << unit->getPlayer()->getName().c_str() << std::endl;
	//R̎S
	/*if(unit->getType().isResourceContainer() && unit->getPlayer() != BWAPI::Broodwar->enemy())
		resourceManager.removeResource(unit);*/

	if (unit->getPlayer() == BWAPI::Broodwar->self()){
		if(unit->getType().isWorker()){
			buildOrderManager.constructionManager.workerManager.removeWorker(unit);
		}else if(unit->getType().isBuilding()){
			buildOrderManager.constructionManager.buildingManager.removeBuilding(unit);
		}else if(unit->getType() == BWAPI::UnitTypes::Zerg_Larva){ //Larva
			buildOrderManager.productionManager.larvaManager.removeLarva(unit); 
		}else if(unit->getType() == BWAPI::UnitTypes::Zerg_Overlord){
			otherUnitManager.removeOtherUnit(unit);
		}else{
			buildOrderManager.productionManager.attackerManager.removeAttacker(unit);
		}
	}

}

