#include "LarvaData.h"

LarvaData::LarvaData(BWAPI::Unit* u):
	UnitData(u),
	buildtype(BWAPI::UnitTypes::None),
	is_morphing(false),
	morph_frame(BWAPI::Broodwar->getFrameCount())
{
	mybase = BWTA::getNearestBaseLocation(getPosition());
}

LarvaData::LarvaData(void) :
	UnitData()
{
}

LarvaData::~LarvaData(void)
{
}

void LarvaData::update(){
	unit_update();
}

BWAPI::UnitType LarvaData::getBuildtype() const
{ return buildtype;}

BWTA::BaseLocation* LarvaData::getMybase() const
{ return mybase;}

bool LarvaData::isMorphing() const
{ return is_morphing;}

int LarvaData::getMorphFrame() const
{ return morph_frame;}

void LarvaData::setBuildtype(BWAPI::UnitType type){
	buildtype = type;
}

void LarvaData::setIsMorphing(bool m){
	is_morphing = m;
}

void LarvaData::setMorphFrame(int frame){
	morph_frame = frame;
}
