#pragma once
#include <BWAPI.h>
#include <BWTA.h>
#include "ResourceManager.h"
#include <map>
#include <vector>
#include <algorithm>
#include <boost/foreach.hpp>
#include <deque>
#include <math.h>
#include "Const.h"

class MapData
{

private:
	std::deque<BWTA::BaseLocation*> ground_base;
	std::deque<BWTA::BaseLocation*> air_base;
	std::deque<BWTA::BaseLocation*> all_base;
	std::map<int, BWTA::BaseLocation*> next_mybase; //Basëʒu
	std::map<BWTA::BaseLocation*, bool> enemybases; //GBaseƂɍSpy邩ǂ
	std::map<BWTA::BaseLocation*, std::vector<BWAPI::Position> > enemybases_position; //GBaseƂ̏ꏊ8̒[
	std::map<int, BWTA::BaseLocation*> enemybases_distance; //GBaseƋ
	std::map<BWTA::BaseLocation*, int> mybases; //BaseƂ̐Y
	int mapwidth;
	int mapheight;
	std::vector<std::vector<bool>> buildable_map; //MapTilePositionŋ؂ABuildingu邩
	std::vector<std::vector<int>> frame_tile; //TileŌɌFrame
	std::vector<std::vector<int>> gradation_frame_tile; //̂ڂ
	int mybase_num; //Base\̐(workerBuildɂȂuԂ+)
	BWAPI::Position wait_position;

public:

	MapData(void);

	~MapData(void);

	void init();

	void update();

	//gbaseframe

	BWTA::BaseLocation* getNextScoutgp();


	//abaseframe

	BWTA::BaseLocation* getNextScoutap();

	//allbase

	BWTA::BaseLocation* getNextScoutp();


	//mybase
	void setMybases(const BWTA::Region *r);

	std::map<BWTA::BaseLocation*, int> getMybases() const;

	int getMybaseState(BWTA::BaseLocation* b);

	void eraseMybases(BWAPI::Position p);

	void eraseMybases(BWTA::BaseLocation *b);



	//enemybases & enemybases_position
	void setEnemybases(const BWTA::Region *r);

	void setEnemybases(BWTA::BaseLocation *b);

	void setEnemybasesBool(BWTA::BaseLocation* b, bool flag);

	std::map<BWTA::BaseLocation*, bool> getEnemybases() const;

	void eraseEnemybases(BWAPI::Position p);

	void eraseEnemybases(BWTA::BaseLocation *b);

	BWTA::BaseLocation* getNearEnemybase();

	BWAPI::Position MapData::getEnemybasesPosition(BWTA::BaseLocation* b, int i) const;

	std::map<BWTA::BaseLocation*, std::vector<BWAPI::Position> > getEnemybasesPosition() const;


	//buildable_map
	void setBuildableMap(int x, int y, bool flag);

	std::vector<std::vector<bool>> getBuildableMap() const;


	//mapwdth & mapheight
	int getMapwidth() const;

	int getMapheight() const;


	//next_mybase & mybase_num
	BWTA::BaseLocation* getNextMybase();

	void setNextMybase(BWTA::BaseLocation* b);

	int getMybaseNum() const;

	void addMybaseNum();

	void subMybaseNum();

	//
	BWTA::BaseLocation* getFrontLine();

	void setWaitPosition();

	void updateWaitPosition(BWAPI::Position p);

	void setWaitToMy();

	BWAPI::Position getWaitPosition();

	void initFrameTile();

	void updateFrameTile();

	void gradateFrameTile(int x, int y);

	std::vector<std::vector<int>> getGradationFrameTile();

	BWAPI::Position getAirScoutPosition(BWAPI::Position p);
};

