#include "ResourceManager.h"


ResourceManager::ResourceManager(void) :
	first(true)
{
}


ResourceManager::~ResourceManager(void)
{
}

void ResourceManager::update(){
	
	if(logging_flag) out << "9.5 - 1,"<< std::endl;
	if(first){
		setState(BWTA::getStartLocation(BWAPI::Broodwar->self()), ResourceState::Mine);
		first = false;
	}

	if(logging_flag) out << "9.5 - 2,"<< std::endl;
	if(!resources.empty()){
		int num = 0;
		BOOST_FOREACH(ResourceData &r, resources){
			if(logging_flag) out << "9.5 - 2 - 0,"<< std::endl;
			if(&r == NULL || r.getUnit() == NULL){
				removeResource(r.getUnit());
				break;
			}
			if(!r.getUnit()->isVisible() || r.getType().isRefinery() || r.getType() == BWAPI::UnitTypes::Resource_Vespene_Geyser) continue;
			if(logging_flag) out << "9.5 - 2 - 1,"<< std::endl;
			//out4 << r.getRemnant() << " " << std::endl;
			if(r.getRemnant() <= 0){
				removeResource(r.getUnit());
				break;
			}

			if(logging_flag) out << "9.5 - 2 - 2,"<< std::endl;
		}
	}
	if(logging_flag) out << "9.5 - 3,"<< std::endl;
}

void ResourceManager::removeResource(BWAPI::Unit *unit){
	ResourceData temp_resource;
	BOOST_FOREACH(ResourceData r, resources){
		if(r.getId() == unit->getID()){
			if(r.getUnit()->getResources() <= 0) temp_resource = r;
			break;
		}
	}
	if(temp_resource.getId() != -1){
		BOOST_FOREACH(WorkerData &w, workers){
			if(w.getTarget() != NULL && w.getTarget()->getId() == temp_resource.getId()){
				w.clearTarget();
			}
		}
		resources.erase(temp_resource);
	}
}

void ResourceManager::createResource(BWAPI::Unit *unit){
	resources.insert(ResourceData(unit));
}

void ResourceManager::setState(BWTA::BaseLocation *b, int i){
	if(!resources.empty()){
		BOOST_FOREACH(ResourceData &r, resources){ //㔼ً̏͋}Ή
			if(r.getPosition().getApproxDistance(b->getPosition()) < TILE_SIZE * 20 && r.getState() != ResourceState::Mine) r.setState(i);
		}
	}
}