#include "UnitData.h"

UnitData::UnitData() :
	unit(NULL),
	id(-1)
{}

UnitData::UnitData(BWAPI::Unit* u) :
	unit(u),
	position(u->getPosition()),
	type(u->getType()),
	id(unit->getID())
{
	size[0] = unit->getType().dimensionLeft();
	size[1] = unit->getType().dimensionUp();
	size[2] = unit->getType().dimensionRight();
	size[3] = unit->getType().dimensionDown();
}

UnitData::~UnitData(void){}

void UnitData::unit_update(){
	if(unit->isVisible()) position = unit->getPosition();
}

BWAPI::Position UnitData::getPosition() const
{ return position;}

const int * UnitData::getSize() const
{ return size;}

BWAPI::Unit * UnitData::getUnit() const 
{ return unit;}

BWAPI::UnitType UnitData::getType() const 
{ return type;}

int UnitData::getId() const 
{ return id;}

void UnitData::setType(BWAPI::UnitType t){
	type = t;
}

bool UnitData::operator==(const UnitData &right) const { return id == right.getId();}

bool UnitData::operator < (const UnitData &right) const { return id < right.getId();}