#include "GenerateBuildOrder.h"


GenerateBuildOrder::GenerateBuildOrder(void)
{
}


GenerateBuildOrder::~GenerateBuildOrder(void)
{
}

void GenerateBuildOrder::init(){

	for(int i=0; i<102; i++){
		for(int j=0; j<BuildOrderType::Max; j++){
			build_order[i][j] = 0;
		}
	}

	if(BWAPI::Broodwar->enemy()->getRace() == BWAPI::Races::Protoss){
		if(strategy_num >= 5) strategy_num = 0;
		switch(strategy_num){
			case 0: createProtoss(); break;
			case 1: createProtoss2(); break;
			case 2: createProtoss3(); break;
			case 3: createProtoss4(); break;
			case 4: createProtoss5(); break;
			default: createProtoss(); break;
		}
	}else if(BWAPI::Broodwar->enemy()->getRace() == BWAPI::Races::Terran){
		if(strategy_num >= 6) strategy_num = 0;
		switch(strategy_num){
			case 0: createTerran(); break;
			case 1: createTerran2(); break;
			case 2: createTerran3(); break;
			case 3: createTerran4(); break;
			case 4: createTerran5(); break;
			case 5: createTerran6(); break;
			default: createTerran(); break;
		}
	}else if(BWAPI::Broodwar->enemy()->getRace() == BWAPI::Races::Zerg){
		if(strategy_num >= 4) strategy_num = 0;
		switch(strategy_num){
			case 0: createZerg(); break;
			case 1: createZerg2(); break;
			case 2: createZerg3(); break;
			case 3: createZerg4(); break;
			default: createZerg(); break;
		}
	}else{
		createProtoss();
	}
	setForRules();
}

void GenerateBuildOrder::createDebug(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 9) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 21) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 15) build_order[i][BuildOrderType::Base] = 2;
		else if(i == 28) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 37) build_order[i][BuildOrderType::Base] = 3;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 15) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		else if(i == 37) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 19) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 28) build_order[i][BuildOrderType::Hatchery] = 4;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 14) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 20) build_order[i][BuildOrderType::QueensNest] = 1;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 25) build_order[i][BuildOrderType::Hive] = 1;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 9) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 20) build_order[i][BuildOrderType::Extractor] = 2;
		else if(i == 33) build_order[i][BuildOrderType::Extractor] = 3;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 12) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i == 9) build_order[i][BuildOrderType::Zergling] = 0;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 15) build_order[i][BuildOrderType::MetabolicBoost] = 0;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 16) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i >= 19) build_order[i][BuildOrderType::Hydralisk] = 5;
		else if(i > 19 && i % 2 == 1) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 1;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i == 20) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i == 25) build_order[i][BuildOrderType::Lurker] = 3;
		else if(i == 40) build_order[i][BuildOrderType::Lurker] = 15;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i >= 26) build_order[i][BuildOrderType::CreepColony] = 0;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i >= 26) build_order[i][BuildOrderType::SunkenColony] = 0;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 18) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 20) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 0;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 21) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 24) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 27) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 21) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 24) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 27) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 30) build_order[i][BuildOrderType::DefilerMound] = 1;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i == 35) build_order[i][BuildOrderType::Defiler] = 2;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}


//Lurker & Mutalisk & Base 1
void GenerateBuildOrder::createZerg(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 12) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 15) build_order[i][BuildOrderType::Base] = 1;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Base] = 1;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 17) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 22) build_order[i][BuildOrderType::Hatchery] = 3;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 15) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 17) build_order[i][BuildOrderType::QueensNest] = 0;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 20) build_order[i][BuildOrderType::Hive] = 0;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 19) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 26) build_order[i][BuildOrderType::Extractor] = 1;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 8) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 10) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 0;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		if(i == 24) build_order[i][BuildOrderType::AdrenalGlands] = 0;
		else build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		if(i == 15) build_order[i][BuildOrderType::EvolutionChamber] = 1;
		else build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		if(i == 17) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 22) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 27) build_order[i][BuildOrderType::Carapace] = 1;
		else build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 1;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		if(i == 17) build_order[i][BuildOrderType::GroovedSpines] = 0;
		else build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i > 17) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i > 20) build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker] + 1;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 9) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 13) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 11) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 15) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 22) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 22) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 25) build_order[i][BuildOrderType::DefilerMound] = 0;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i >= 27 && i <= 31) build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler] + 0;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		if(i == 28) build_order[i][BuildOrderType::DarkSwarm] = 0;
		else build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//Lurker & Mutalisk & Base 3
void GenerateBuildOrder::createZerg2(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 12) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 15) build_order[i][BuildOrderType::Base] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Base] = 3;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 15) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Hatchery] = 4;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 15) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 17) build_order[i][BuildOrderType::QueensNest] = 0;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 20) build_order[i][BuildOrderType::Hive] = 0;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 19) build_order[i][BuildOrderType::Extractor] = 2;
		else if(i == 33) build_order[i][BuildOrderType::Extractor] = 3;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 8) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 10) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 0;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		if(i == 24) build_order[i][BuildOrderType::AdrenalGlands] = 0;
		else build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		if(i == 15) build_order[i][BuildOrderType::EvolutionChamber] = 1;
		else build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		if(i == 17) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 22) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 27) build_order[i][BuildOrderType::Carapace] = 1;
		else build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 1;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		if(i == 17) build_order[i][BuildOrderType::GroovedSpines] = 0;
		else build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i > 17) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i > 20) build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker] + 1;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 9) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 18) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 11) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 21) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 22) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 22) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 25) build_order[i][BuildOrderType::DefilerMound] = 0;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i >= 27 && i <= 31) build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler] + 0;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		if(i == 28) build_order[i][BuildOrderType::DarkSwarm] = 0;
		else build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//ZerglingRush
void GenerateBuildOrder::createZerg3(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=4; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 9) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 13) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 20 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 15) build_order[i][BuildOrderType::Base] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Base] = 3;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 15) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		//else if(i == 17) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Hatchery] = 4;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 15) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 19) build_order[i][BuildOrderType::QueensNest] = 1;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 25) build_order[i][BuildOrderType::Hive] = 1;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 19) build_order[i][BuildOrderType::Extractor] = 2;
		else if(i == 35) build_order[i][BuildOrderType::Extractor] = 3;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 4) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 12) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else if(i == 4) build_order[i][BuildOrderType::Zergling] = 4;
		else if(i == 5) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 1;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		if(i == 29) build_order[i][BuildOrderType::AdrenalGlands] = 1;
		else build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		if(i == 15) build_order[i][BuildOrderType::EvolutionChamber] = 1;
		else build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		if(i == 17) build_order[i][BuildOrderType::Carapace] = 1;
		//else if(i == 22) build_order[i][BuildOrderType::Carapace] = 1;
		//else if(i == 27) build_order[i][BuildOrderType::Carapace] = 1;
		else build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		if(i == 24) build_order[i][BuildOrderType::MeleeAtack] = 1;
		//else if(i == 22) build_order[i][BuildOrderType::MeleeAtack] = 1;
		//else if(i == 27) build_order[i][BuildOrderType::MeleeAtack] = 1;
		else build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 2;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		if(i == 17) build_order[i][BuildOrderType::GroovedSpines] = 0;
		else build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i == 17) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i > 20) build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker] + 1;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 10) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 20) build_order[i][BuildOrderType::CreepColony] = 2;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 9) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 12) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 22) build_order[i][BuildOrderType::SunkenColony] = 2;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 18) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 21) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 25) build_order[i][BuildOrderType::DefilerMound] = 0;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i >= 27 && i <= 31) build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler] + 1;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		if(i == 28) build_order[i][BuildOrderType::DarkSwarm] = 0;
		else build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//ՖhAMutaliskRush
void GenerateBuildOrder::createZerg4(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 12) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 40) build_order[i][BuildOrderType::Base] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		//else if(i == 24) build_order[i][BuildOrderType::Base] = 4;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 19) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 24) build_order[i][BuildOrderType::Hatchery] = 7;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 19) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 17) build_order[i][BuildOrderType::QueensNest] = 0;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 20) build_order[i][BuildOrderType::Hive] = 0;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		//else if(i == 20) build_order[i][BuildOrderType::Extractor] = 2;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 8) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 10) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 0;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 0;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 0;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 9) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 13) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 11) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 14) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 22) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 1;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 25) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}




//Lurker & Mutalisk & Base 1
void GenerateBuildOrder::createProtoss(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 12) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 15) build_order[i][BuildOrderType::Base] = 1;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Base] = 1;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 17) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 22) build_order[i][BuildOrderType::Hatchery] = 3;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 15) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 17) build_order[i][BuildOrderType::QueensNest] = 0;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 20) build_order[i][BuildOrderType::Hive] = 0;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 19) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 26) build_order[i][BuildOrderType::Extractor] = 1;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 8) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 10) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 0;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		if(i == 24) build_order[i][BuildOrderType::AdrenalGlands] = 0;
		else build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		if(i == 15) build_order[i][BuildOrderType::EvolutionChamber] = 1;
		else build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		if(i == 17) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 22) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 27) build_order[i][BuildOrderType::Carapace] = 1;
		else build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 1;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		if(i == 17) build_order[i][BuildOrderType::GroovedSpines] = 0;
		else build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i > 17) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i > 20) build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker] + 1;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 9) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 13) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 11) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 15) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 22) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 22) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 25) build_order[i][BuildOrderType::DefilerMound] = 0;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i >= 27 && i <= 31) build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler] + 0;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		if(i == 28) build_order[i][BuildOrderType::DarkSwarm] = 0;
		else build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//Lurker & Mutalisk & Base 3
void GenerateBuildOrder::createProtoss2(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 12) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 15) build_order[i][BuildOrderType::Base] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Base] = 3;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 15) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Hatchery] = 4;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 15) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 17) build_order[i][BuildOrderType::QueensNest] = 0;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 20) build_order[i][BuildOrderType::Hive] = 0;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 19) build_order[i][BuildOrderType::Extractor] = 2;
		else if(i == 33) build_order[i][BuildOrderType::Extractor] = 3;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 8) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 10) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 0;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		if(i == 24) build_order[i][BuildOrderType::AdrenalGlands] = 0;
		else build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		if(i == 15) build_order[i][BuildOrderType::EvolutionChamber] = 1;
		else build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		if(i == 17) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 22) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 27) build_order[i][BuildOrderType::Carapace] = 1;
		else build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 1;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		if(i == 17) build_order[i][BuildOrderType::GroovedSpines] = 0;
		else build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i > 17) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i > 20) build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker] + 1;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 9) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 18) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 11) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 21) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 22) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 22) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 25) build_order[i][BuildOrderType::DefilerMound] = 0;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i >= 27 && i <= 31) build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler] + 0;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		if(i == 28) build_order[i][BuildOrderType::DarkSwarm] = 0;
		else build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//ZerglingRush
void GenerateBuildOrder::createProtoss3(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=4; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 9) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 13) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 20 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 15) build_order[i][BuildOrderType::Base] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Base] = 3;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 15) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		//else if(i == 17) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Hatchery] = 4;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 15) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 19) build_order[i][BuildOrderType::QueensNest] = 1;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 25) build_order[i][BuildOrderType::Hive] = 1;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 19) build_order[i][BuildOrderType::Extractor] = 2;
		else if(i == 35) build_order[i][BuildOrderType::Extractor] = 3;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 4) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 12) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else if(i == 4) build_order[i][BuildOrderType::Zergling] = 4;
		else if(i == 5) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 1;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		if(i == 29) build_order[i][BuildOrderType::AdrenalGlands] = 1;
		else build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		if(i == 15) build_order[i][BuildOrderType::EvolutionChamber] = 1;
		else build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		if(i == 17) build_order[i][BuildOrderType::Carapace] = 1;
		//else if(i == 22) build_order[i][BuildOrderType::Carapace] = 1;
		//else if(i == 27) build_order[i][BuildOrderType::Carapace] = 1;
		else build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		if(i == 24) build_order[i][BuildOrderType::MeleeAtack] = 1;
		//else if(i == 22) build_order[i][BuildOrderType::MeleeAtack] = 1;
		//else if(i == 27) build_order[i][BuildOrderType::MeleeAtack] = 1;
		else build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 2;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		if(i == 17) build_order[i][BuildOrderType::GroovedSpines] = 0;
		else build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i == 17) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i > 20) build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker] + 1;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 10) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 20) build_order[i][BuildOrderType::CreepColony] = 2;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 9) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 12) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 22) build_order[i][BuildOrderType::SunkenColony] = 2;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 18) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 21) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 25) build_order[i][BuildOrderType::DefilerMound] = 0;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i >= 27 && i <= 31) build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler] + 1;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		if(i == 28) build_order[i][BuildOrderType::DarkSwarm] = 0;
		else build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//ՖhAMutaliskRush
void GenerateBuildOrder::createProtoss4(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 12) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 40) build_order[i][BuildOrderType::Base] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		//else if(i == 24) build_order[i][BuildOrderType::Base] = 4;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 19) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 24) build_order[i][BuildOrderType::Hatchery] = 7;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 19) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 17) build_order[i][BuildOrderType::QueensNest] = 0;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 20) build_order[i][BuildOrderType::Hive] = 0;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		//else if(i == 20) build_order[i][BuildOrderType::Extractor] = 2;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 8) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 10) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 0;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 0;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 0;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 9) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 13) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 11) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 14) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 22) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 1;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 25) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//MutaliskRush
void GenerateBuildOrder::createProtoss5(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 9) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 14) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 18) build_order[i][BuildOrderType::Overload] = 4;
		//else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 13) build_order[i][BuildOrderType::Base] = 2;
		else if(i == 24) build_order[i][BuildOrderType::Base] = 3;
		//else if(i == 24) build_order[i][BuildOrderType::Base] = 4;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 13) build_order[i][BuildOrderType::Hatchery] = 2;
		else if(i == 21) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 24) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 24) build_order[i][BuildOrderType::Hatchery] = 7;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 14) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 17) build_order[i][BuildOrderType::QueensNest] = 0;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 20) build_order[i][BuildOrderType::Hive] = 0;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 20) build_order[i][BuildOrderType::Extractor] = 2;
		else if(i == 28) build_order[i][BuildOrderType::Extractor] = 3;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 13) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i > 24) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 6;
		else if(i == 14) build_order[i][BuildOrderType::Zergling] = 0;
		else if(i == 15) build_order[i][BuildOrderType::Zergling] = 0;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 0;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 0;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 0;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 17) build_order[i][BuildOrderType::CreepColony] = 0;
		//else if(i == 9) build_order[i][BuildOrderType::CreepColony] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 19) build_order[i][BuildOrderType::SunkenColony] = 0;
		//else if(i == 11) build_order[i][BuildOrderType::SunkenColony] = 2;
		//else if(i == 14) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 20) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 24) build_order[i][BuildOrderType::Spire] = 2;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 24) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else if(i == 24) build_order[i][BuildOrderType::Mutalisk] = 5;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		if(i > 20) build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge] + 0;
		else build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 24) build_order[i][BuildOrderType::FlyerCarapace] = 1;
		else if(i == 32) build_order[i][BuildOrderType::FlyerCarapace] = 2;
		//else if(i == 32) build_order[i][BuildOrderType::FlyerCarapace] = 3;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 1;
		else if(i == 36) build_order[i][BuildOrderType::FlyerAttacks] = 2;
		//else if(i == 32) build_order[i][BuildOrderType::FlyerAttacks] = 3;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}





//Lurker & Mutalisk & Base 1
void GenerateBuildOrder::createTerran(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 12) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 15) build_order[i][BuildOrderType::Base] = 1;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Base] = 1;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 17) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 22) build_order[i][BuildOrderType::Hatchery] = 3;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 15) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 17) build_order[i][BuildOrderType::QueensNest] = 0;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 20) build_order[i][BuildOrderType::Hive] = 0;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 19) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 26) build_order[i][BuildOrderType::Extractor] = 1;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 8) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 10) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 0;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		if(i == 24) build_order[i][BuildOrderType::AdrenalGlands] = 0;
		else build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		if(i == 15) build_order[i][BuildOrderType::EvolutionChamber] = 1;
		else build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		if(i == 17) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 22) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 27) build_order[i][BuildOrderType::Carapace] = 1;
		else build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 1;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		if(i == 17) build_order[i][BuildOrderType::GroovedSpines] = 0;
		else build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i > 17) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i > 20) build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker] + 1;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 9) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 13) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 11) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 15) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 22) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 22) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 25) build_order[i][BuildOrderType::DefilerMound] = 0;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i >= 27 && i <= 31) build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler] + 0;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		if(i == 28) build_order[i][BuildOrderType::DarkSwarm] = 0;
		else build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//Lurker & Mutalisk & Base 3
void GenerateBuildOrder::createTerran2(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 12) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 15) build_order[i][BuildOrderType::Base] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Base] = 3;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 15) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Hatchery] = 4;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 15) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 17) build_order[i][BuildOrderType::QueensNest] = 0;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 20) build_order[i][BuildOrderType::Hive] = 0;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 19) build_order[i][BuildOrderType::Extractor] = 2;
		else if(i == 33) build_order[i][BuildOrderType::Extractor] = 3;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 8) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 10) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 0;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		if(i == 24) build_order[i][BuildOrderType::AdrenalGlands] = 0;
		else build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		if(i == 15) build_order[i][BuildOrderType::EvolutionChamber] = 1;
		else build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		if(i == 17) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 22) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 27) build_order[i][BuildOrderType::Carapace] = 1;
		else build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 1;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		if(i == 17) build_order[i][BuildOrderType::GroovedSpines] = 0;
		else build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i > 17) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i > 20) build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker] + 1;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 9) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 18) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 11) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 21) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 22) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 22) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 25) build_order[i][BuildOrderType::DefilerMound] = 0;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i >= 27 && i <= 31) build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler] + 0;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		if(i == 28) build_order[i][BuildOrderType::DarkSwarm] = 0;
		else build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//ZerglingRush
void GenerateBuildOrder::createTerran3(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=4; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 9) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 13) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 20 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 15) build_order[i][BuildOrderType::Base] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Base] = 3;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 15) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		//else if(i == 17) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Hatchery] = 4;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 15) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 19) build_order[i][BuildOrderType::QueensNest] = 1;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 25) build_order[i][BuildOrderType::Hive] = 1;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 19) build_order[i][BuildOrderType::Extractor] = 2;
		else if(i == 35) build_order[i][BuildOrderType::Extractor] = 3;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 4) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 12) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else if(i == 4) build_order[i][BuildOrderType::Zergling] = 4;
		else if(i == 5) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 1;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		if(i == 29) build_order[i][BuildOrderType::AdrenalGlands] = 1;
		else build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		if(i == 15) build_order[i][BuildOrderType::EvolutionChamber] = 1;
		else build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		if(i == 17) build_order[i][BuildOrderType::Carapace] = 1;
		//else if(i == 22) build_order[i][BuildOrderType::Carapace] = 1;
		//else if(i == 27) build_order[i][BuildOrderType::Carapace] = 1;
		else build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		if(i == 24) build_order[i][BuildOrderType::MeleeAtack] = 1;
		//else if(i == 22) build_order[i][BuildOrderType::MeleeAtack] = 1;
		//else if(i == 27) build_order[i][BuildOrderType::MeleeAtack] = 1;
		else build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 2;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		if(i == 17) build_order[i][BuildOrderType::GroovedSpines] = 0;
		else build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i == 17) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i > 20) build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker] + 1;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 10) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 20) build_order[i][BuildOrderType::CreepColony] = 2;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 9) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 12) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 22) build_order[i][BuildOrderType::SunkenColony] = 2;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 18) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 21) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 25) build_order[i][BuildOrderType::DefilerMound] = 0;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i >= 27 && i <= 31) build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler] + 1;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		if(i == 28) build_order[i][BuildOrderType::DarkSwarm] = 0;
		else build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//Lurker
void GenerateBuildOrder::createTerran4(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 12) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 15) build_order[i][BuildOrderType::Base] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Base] = 3;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 17) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 22) build_order[i][BuildOrderType::Hatchery] = 4;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 15) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 17) build_order[i][BuildOrderType::QueensNest] = 1;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 20) build_order[i][BuildOrderType::Hive] = 1;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 19) build_order[i][BuildOrderType::Extractor] = 2;
		else if(i == 26) build_order[i][BuildOrderType::Extractor] = 3;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 8) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 10) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 1;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		if(i == 24) build_order[i][BuildOrderType::AdrenalGlands] = 1;
		else build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		if(i == 15) build_order[i][BuildOrderType::EvolutionChamber] = 1;
		else build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		if(i == 17) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 22) build_order[i][BuildOrderType::Carapace] = 2;
		else if(i == 27) build_order[i][BuildOrderType::Carapace] = 2;
		else build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 2;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		if(i == 17) build_order[i][BuildOrderType::GroovedSpines] = 0;
		else build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i > 17) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i > 20) build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker] + 1;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 9) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 20) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 11) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 22) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 22) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 25) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 25) build_order[i][BuildOrderType::DefilerMound] = 0;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i >= 27 && i <= 31) build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler] + 1;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		if(i == 28) build_order[i][BuildOrderType::DarkSwarm] = 0;
		else build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//
void GenerateBuildOrder::createTerran5(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 12) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 20) build_order[i][BuildOrderType::Base] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Base] = 3;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 20) build_order[i][BuildOrderType::Hatchery] = 3;
		else if(i == 30) build_order[i][BuildOrderType::Hatchery] = 4;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 17) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 19) build_order[i][BuildOrderType::QueensNest] = 1;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 22) build_order[i][BuildOrderType::Hive] = 1;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 14) build_order[i][BuildOrderType::Extractor] = 1;
		else if(i == 25) build_order[i][BuildOrderType::Extractor] = 2;
		else if(i == 35) build_order[i][BuildOrderType::Extractor] = 3;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 8) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 10) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 19) build_order[i][BuildOrderType::MetabolicBoost] = 1;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		if(i == 28) build_order[i][BuildOrderType::AdrenalGlands] = 1;
		else build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		if(i == 15) build_order[i][BuildOrderType::EvolutionChamber] = 1;
		else build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		if(i == 17) build_order[i][BuildOrderType::Carapace] = 1;
		else if(i == 22) build_order[i][BuildOrderType::Carapace] = 2;
		else if(i == 27) build_order[i][BuildOrderType::Carapace] = 2;
		else build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 17) build_order[i][BuildOrderType::HydraliskDen] = 1;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 19) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 2;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		if(i == 17) build_order[i][BuildOrderType::GroovedSpines] = 0;
		else build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		if(i > 22) build_order[i][BuildOrderType::LurkerAspect] = 1;
		else build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		if(i > 24) build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker] + 1;
		else build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 11) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 20) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 13) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 22) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 28) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 0;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 30) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		if(i == 25) build_order[i][BuildOrderType::DefilerMound] = 0;
		else build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		if(i >= 27 && i <= 31) build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler] + 1;
		else build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		if(i == 28) build_order[i][BuildOrderType::DarkSwarm] = 0;
		else build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}

//ՖhAMutaliskRush
void GenerateBuildOrder::createTerran6(){
	for(int i=1; i<=4; i++){
		build_order[i][BuildOrderType::Base]     = 1;
		build_order[i][BuildOrderType::Hatchery] = 1;
		build_order[i][BuildOrderType::Overload] = 1;
	}

	for(int i=5; i<=100; i++){

//////about Overload

		//Overload
		if(i == 7) build_order[i][BuildOrderType::Overload] = 2;
		else if(i == 12) build_order[i][BuildOrderType::Overload] = 3;
		else if(i == 16) build_order[i][BuildOrderType::Overload] = 4;
		else if(i == 20) build_order[i][BuildOrderType::Overload] = 5;
		else if(i >= 22 && i % 3 == 0) build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload] + 1;
		else build_order[i][BuildOrderType::Overload] = build_order[i-1][BuildOrderType::Overload];

		//VentralSacs
		build_order[i][BuildOrderType::VentralSacs] = build_order[i-1][BuildOrderType::VentralSacs];
		//Antennae
		build_order[i][BuildOrderType::Antennae] = build_order[i-1][BuildOrderType::Antennae];
		//PneumatizedCarapace
		build_order[i][BuildOrderType::PneumatizedCarapace] = build_order[i-1][BuildOrderType::PneumatizedCarapace];



//////about Hatchery

		//Base
		if(i == 40) build_order[i][BuildOrderType::Base] = 2;
		//else if(i == 13) build_order[i][BuildOrderType::Base] = 3;
		//else if(i == 24) build_order[i][BuildOrderType::Base] = 4;
		else build_order[i][BuildOrderType::Base] = build_order[i-1][BuildOrderType::Base];

		//Hatchery
		if(i == 9) build_order[i][BuildOrderType::Hatchery] = 2;
		//else if(i == 11) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 13) build_order[i][BuildOrderType::Hatchery] = 4;
		//else if(i == 16) build_order[i][BuildOrderType::Hatchery] = 5;
		else if(i == 19) build_order[i][BuildOrderType::Hatchery] = 3;
		//else if(i == 24) build_order[i][BuildOrderType::Hatchery] = 7;
		else build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery];

		//Lair
		if(i == 19) build_order[i][BuildOrderType::Lair] = 1;
		else build_order[i][BuildOrderType::Lair] = build_order[i-1][BuildOrderType::Lair];

		//QueensNest
		if(i == 17) build_order[i][BuildOrderType::QueensNest] = 0;
		else build_order[i][BuildOrderType::QueensNest] = build_order[i-1][BuildOrderType::QueensNest];

		//Hive
		if(i == 20) build_order[i][BuildOrderType::Hive] = 0;
		else build_order[i][BuildOrderType::Hive] = build_order[i-1][BuildOrderType::Hive];

		//Burrowing
		build_order[i][BuildOrderType::Burrowing] = build_order[i-1][BuildOrderType::Burrowing];

		//Extractor
		if(i == 12) build_order[i][BuildOrderType::Extractor] = 1;
		//else if(i == 20) build_order[i][BuildOrderType::Extractor] = 2;
		else build_order[i][BuildOrderType::Extractor] = build_order[i-1][BuildOrderType::Extractor];



//////about Zergling

		//SpawningPool
		if(i == 8) build_order[i][BuildOrderType::SpawningPool] = 1;
		else build_order[i][BuildOrderType::SpawningPool] = build_order[i-1][BuildOrderType::SpawningPool];

		//Zergling
		if(i >= 10) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		//else if(i == 9) build_order[i][BuildOrderType::Zergling] = 8;
		//else if(i == 13) build_order[i][BuildOrderType::Zergling] = 12;
		//else if(i >= 20 && i % 2 == 0) build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling] + 2;
		else build_order[i][BuildOrderType::Zergling] = build_order[i-1][BuildOrderType::Zergling];

		//MetabolicBoost
		if(i == 17) build_order[i][BuildOrderType::MetabolicBoost] = 0;
		else build_order[i][BuildOrderType::MetabolicBoost] = build_order[i-1][BuildOrderType::MetabolicBoost];

		//AdrenalGlands
		build_order[i][BuildOrderType::AdrenalGlands] = build_order[i-1][BuildOrderType::AdrenalGlands];


//////about Ultralisk

		//UltraliskCavern
		build_order[i][BuildOrderType::UltraliskCavern] = build_order[i-1][BuildOrderType::UltraliskCavern];

		//Ultralisk
		build_order[i][BuildOrderType::Ultralisk] = build_order[i-1][BuildOrderType::Ultralisk];

		//ChitinousPlating
		build_order[i][BuildOrderType::ChitinousPlating] = build_order[i-1][BuildOrderType::ChitinousPlating];
		//AnabolicSynthesis
		build_order[i][BuildOrderType::AnabolicSynthesis] = build_order[i-1][BuildOrderType::AnabolicSynthesis];


//////about EvolutionChamber

		//EvolutionChamber
		build_order[i][BuildOrderType::EvolutionChamber] = build_order[i-1][BuildOrderType::EvolutionChamber];

		//Carapace
		build_order[i][BuildOrderType::Carapace] = build_order[i-1][BuildOrderType::Carapace];
		//MeleeAtack
		build_order[i][BuildOrderType::MeleeAtack] = build_order[i-1][BuildOrderType::MeleeAtack];
		//MissileAttacks
		build_order[i][BuildOrderType::MissileAttacks] = build_order[i-1][BuildOrderType::MissileAttacks];


//////about Hydralisk

		//HydraliskDen
		if(i == 13) build_order[i][BuildOrderType::HydraliskDen] = 0;
		else build_order[i][BuildOrderType::HydraliskDen] = build_order[i-1][BuildOrderType::HydraliskDen];

		//Hydralisk
		if(i > 15) build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk] + 0;
		else build_order[i][BuildOrderType::Hydralisk] = build_order[i-1][BuildOrderType::Hydralisk];


		//MuscularAugment
		build_order[i][BuildOrderType::MuscularAugment] = build_order[i-1][BuildOrderType::MuscularAugment];
		//GroovedSpines
		build_order[i][BuildOrderType::GroovedSpines] = build_order[i-1][BuildOrderType::GroovedSpines];

//////about Lurker

		//LurkerAspect
		build_order[i][BuildOrderType::LurkerAspect] = build_order[i-1][BuildOrderType::LurkerAspect];

		//Lurker
		build_order[i][BuildOrderType::Lurker] = build_order[i-1][BuildOrderType::Lurker];


//////about CreepColony

		//CreepColony
		if(i == 8) build_order[i][BuildOrderType::CreepColony] = 1;
		else if(i == 9) build_order[i][BuildOrderType::CreepColony] = 2;
		else if(i == 13) build_order[i][BuildOrderType::CreepColony] = 3;
		else build_order[i][BuildOrderType::CreepColony] = build_order[i-1][BuildOrderType::CreepColony];

		//SunkenColony
		if(i == 10) build_order[i][BuildOrderType::SunkenColony] = 1;
		else if(i == 11) build_order[i][BuildOrderType::SunkenColony] = 2;
		else if(i == 14) build_order[i][BuildOrderType::SunkenColony] = 3;
		else build_order[i][BuildOrderType::SunkenColony] = build_order[i-1][BuildOrderType::SunkenColony];

		//SporeColony
		build_order[i][BuildOrderType::SporeColony] = build_order[i-1][BuildOrderType::SporeColony];



//////about Flyer

		//Spire
		if(i == 22) build_order[i][BuildOrderType::Spire] = 1;
		else if(i == 28) build_order[i][BuildOrderType::Spire] = 1;
		else build_order[i][BuildOrderType::Spire] = build_order[i-1][BuildOrderType::Spire];

		//Mutalisk
		if(i > 25) build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk] + 1;
		else build_order[i][BuildOrderType::Mutalisk] = build_order[i-1][BuildOrderType::Mutalisk];

		//Scourge
		build_order[i][BuildOrderType::Scourge] = build_order[i-1][BuildOrderType::Scourge];

		//GreaterSpire
		build_order[i][BuildOrderType::GreaterSpire] = build_order[i-1][BuildOrderType::GreaterSpire];

		//Devourer
		build_order[i][BuildOrderType::Devourer] = build_order[i-1][BuildOrderType::Devourer];
		//Guardian
		build_order[i][BuildOrderType::Guardian] = build_order[i-1][BuildOrderType::Guardian];

		//FlyerCarapace
		if(i == 28) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerCarapace] = 0;
		else build_order[i][BuildOrderType::FlyerCarapace] = build_order[i-1][BuildOrderType::FlyerCarapace];
		//FlyerAttacks
		if(i == 28) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 33) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else if(i == 38) build_order[i][BuildOrderType::FlyerAttacks] = 0;
		else build_order[i][BuildOrderType::FlyerAttacks] = build_order[i-1][BuildOrderType::FlyerAttacks];



//////about Defiler

		//DefilerMound
		build_order[i][BuildOrderType::DefilerMound] = build_order[i-1][BuildOrderType::DefilerMound];

		//Defiler
		build_order[i][BuildOrderType::Defiler] = build_order[i-1][BuildOrderType::Defiler];

		//DarkSwarm
		build_order[i][BuildOrderType::DarkSwarm] = build_order[i-1][BuildOrderType::DarkSwarm];
		//Plague
		build_order[i][BuildOrderType::Plague] = build_order[i-1][BuildOrderType::Plague];
		//Consume
		build_order[i][BuildOrderType::Consume] = build_order[i-1][BuildOrderType::Consume];


//////about queen

		//Queen
		build_order[i][BuildOrderType::Queen] = build_order[i-1][BuildOrderType::Queen];

		//Brooding
		build_order[i][BuildOrderType::Brooding] = build_order[i-1][BuildOrderType::Brooding];

		//Infestation
		build_order[i][BuildOrderType::Infestation] = build_order[i-1][BuildOrderType::Infestation];
		//SpawnBroodings
		build_order[i][BuildOrderType::SpawnBroodings] = build_order[i-1][BuildOrderType::SpawnBroodings];
		//Ensnare
		build_order[i][BuildOrderType::Ensnare] = build_order[i-1][BuildOrderType::Ensnare];
		//Parasite
		build_order[i][BuildOrderType::Parasite] = build_order[i-1][BuildOrderType::Parasite];
		//GameteMeiosis
		build_order[i][BuildOrderType::GameteMeiosis] = build_order[i-1][BuildOrderType::GameteMeiosis];
		
//////other...	
		//NydusCanel
		build_order[i][BuildOrderType::NydusCanel] = build_order[i-1][BuildOrderType::NydusCanel];
	}

	for(int j=0; j<BuildOrderType::Max; j++) build_order[101][j] = 2000;
}



void GenerateBuildOrder::setForRules(){
	for(int i=4; i<=100; i++){
		if(build_order[i][BuildOrderType::Burrowing] > 1) build_order[i][BuildOrderType::Burrowing] = 1;
		if(build_order[i][BuildOrderType::Plague] > 1) build_order[i][BuildOrderType::Plague] = 1;
		if(build_order[i][BuildOrderType::Consume] > 1)	build_order[i][BuildOrderType::Consume] = 1;
		if(build_order[i][BuildOrderType::MetasynapticNode] > 1) build_order[i][BuildOrderType::MetasynapticNode] = 1;
		if(build_order[i][BuildOrderType::MuscularAugment] > 1) build_order[i][BuildOrderType::MuscularAugment] = 1;
		if(build_order[i][BuildOrderType::GroovedSpines] > 1) build_order[i][BuildOrderType::GroovedSpines] = 1;
		if(build_order[i][BuildOrderType::LurkerAspect] > 1) build_order[i][BuildOrderType::LurkerAspect] = 1;
		if(build_order[i][BuildOrderType::Antennae] > 1) build_order[i][BuildOrderType::Antennae] = 1;
		if(build_order[i][BuildOrderType::PneumatizedCarapace] > 1) build_order[i][BuildOrderType::PneumatizedCarapace] = 1;
		if(build_order[i][BuildOrderType::VentralSacs] > 1) build_order[i][BuildOrderType::VentralSacs] = 1;
		if(build_order[i][BuildOrderType::Ensnare] > 1) build_order[i][BuildOrderType::Ensnare] = 1;
		if(build_order[i][BuildOrderType::SpawnBroodings] > 1) build_order[i][BuildOrderType::SpawnBroodings] = 1;
		if(build_order[i][BuildOrderType::GameteMeiosis] > 1) build_order[i][BuildOrderType::GameteMeiosis] = 1;
		if(build_order[i][BuildOrderType::MetabolicBoost] > 1) build_order[i][BuildOrderType::MetabolicBoost] = 1;
		if(build_order[i][BuildOrderType::AdrenalGlands] > 1) build_order[i][BuildOrderType::AdrenalGlands] = 1;
		if(build_order[i][BuildOrderType::AnabolicSynthesis] > 1) build_order[i][BuildOrderType::AnabolicSynthesis] = 1;
		if(build_order[i][BuildOrderType::ChitinousPlating] > 1) build_order[i][BuildOrderType::ChitinousPlating] = 1;
		if(build_order[i][BuildOrderType::Carapace] > 3) build_order[i][BuildOrderType::Carapace] = 3;
		if(build_order[i][BuildOrderType::MissileAttacks] > 3) build_order[i][BuildOrderType::MissileAttacks] = 3;
		if(build_order[i][BuildOrderType::MeleeAtack] > 3) build_order[i][BuildOrderType::MeleeAtack] = 3;
		if(build_order[i][BuildOrderType::FlyerAttacks] > 3) build_order[i][BuildOrderType::FlyerAttacks] = 3;
		if(build_order[i][BuildOrderType::FlyerCarapace] > 3) build_order[i][BuildOrderType::FlyerCarapace] = 3;

		if(build_order[i][BuildOrderType::Hatchery] == 0){
			build_order[i][BuildOrderType::EvolutionChamber] = 0;
			build_order[i][BuildOrderType::SpawningPool]     = 0;
			build_order[i][BuildOrderType::Burrowing]        = 0;

		}

		if(build_order[i][BuildOrderType::EvolutionChamber] == 0){
			build_order[i][BuildOrderType::SporeColony]    = 0;
			build_order[i][BuildOrderType::Carapace]       = 0;
			build_order[i][BuildOrderType::MissileAttacks] = 0;
			build_order[i][BuildOrderType::MeleeAtack]     = 0;
		}

		if(build_order[i][BuildOrderType::SpawningPool] == 0){
			build_order[i][BuildOrderType::SunkenColony]   = 0;
			build_order[i][BuildOrderType::Lair]           = 0;
			build_order[i][BuildOrderType::HydraliskDen]   = 0;
			build_order[i][BuildOrderType::MetabolicBoost] = 0;
		}

		if(build_order[i][BuildOrderType::Extractor] == 0){
			build_order[i][BuildOrderType::Lair]         = 0;
			build_order[i][BuildOrderType::HydraliskDen] = 0;
		}

		if(build_order[i][BuildOrderType::Lair] == 0){
			build_order[i][BuildOrderType::LurkerAspect]        = 0;
			build_order[i][BuildOrderType::QueensNest]          = 0;
			build_order[i][BuildOrderType::Hive]                = 0;
			build_order[i][BuildOrderType::Spire]               = 0;
			build_order[i][BuildOrderType::Antennae]            = 0;
			build_order[i][BuildOrderType::PneumatizedCarapace] = 0;
			build_order[i][BuildOrderType::VentralSacs]         = 0;
			if(build_order[i][BuildOrderType::FlyerAttacks] > 1) build_order[i][BuildOrderType::FlyerAttacks] = 1;
			if(build_order[i][BuildOrderType::FlyerCarapace] > 1) build_order[i][BuildOrderType::FlyerCarapace] = 1;
			if(build_order[i][BuildOrderType::Carapace] > 1) build_order[i][BuildOrderType::Carapace] = 1;
			if(build_order[i][BuildOrderType::MissileAttacks] > 1) build_order[i][BuildOrderType::MissileAttacks] = 1;
			if(build_order[i][BuildOrderType::MeleeAtack] > 1) build_order[i][BuildOrderType::MeleeAtack] = 1;
		}

		if(build_order[i][BuildOrderType::QueensNest] == 0){
			build_order[i][BuildOrderType::Hive]           = 0;
			build_order[i][BuildOrderType::Ensnare]        = 0;
			build_order[i][BuildOrderType::SpawnBroodings] = 0;
			build_order[i][BuildOrderType::GameteMeiosis] = 0;

		}

		if(build_order[i][BuildOrderType::Spire] == 0){
			build_order[i][BuildOrderType::GreaterSpire] = 0;
			build_order[i][BuildOrderType::FlyerAttacks] = 0;
			build_order[i][BuildOrderType::FlyerCarapace] = 0;
		}

		if(build_order[i][BuildOrderType::Hive] == 0){
			build_order[i][BuildOrderType::DefilerMound]    = 0;
			build_order[i][BuildOrderType::NydusCanel]      = 0;
			build_order[i][BuildOrderType::UltraliskCavern] = 0;
			build_order[i][BuildOrderType::GreaterSpire]    = 0;
			build_order[i][BuildOrderType::AdrenalGlands]   = 0;
			if(build_order[i][BuildOrderType::FlyerAttacks] > 2) build_order[i][BuildOrderType::FlyerAttacks] = 2;
			if(build_order[i][BuildOrderType::FlyerCarapace] > 2) build_order[i][BuildOrderType::FlyerCarapace] = 2;
			if(build_order[i][BuildOrderType::Carapace] > 2) build_order[i][BuildOrderType::Carapace] = 2;
			if(build_order[i][BuildOrderType::MissileAttacks] > 2) build_order[i][BuildOrderType::MissileAttacks] = 2;
			if(build_order[i][BuildOrderType::MeleeAtack] > 2) build_order[i][BuildOrderType::MeleeAtack] = 2;
		}

		if(build_order[i][BuildOrderType::SpawningPool] == 0){
			build_order[i][BuildOrderType::Zergling] = 0;
		}

		if(build_order[i][BuildOrderType::DefilerMound] == 0){
			build_order[i][BuildOrderType::Defiler]          = 0;
			build_order[i][BuildOrderType::Plague]           = 0;
			build_order[i][BuildOrderType::Consume]          = 0;
			build_order[i][BuildOrderType::MetasynapticNode] = 0;
		}

		if(build_order[i][BuildOrderType::HydraliskDen] == 0){
			build_order[i][BuildOrderType::Hydralisk]       = 0;
			build_order[i][BuildOrderType::MuscularAugment] = 0;
			build_order[i][BuildOrderType::GroovedSpines]   = 0;
			build_order[i][BuildOrderType::LurkerAspect]    = 0;
		}

		if(build_order[i][BuildOrderType::Hydralisk] == 0 || build_order[i][BuildOrderType::LurkerAspect] == 0){ //TechKv
			build_order[i][BuildOrderType::Lurker] = 0;
		}

		if(build_order[i][BuildOrderType::UltraliskCavern] == 0){
			build_order[i][BuildOrderType::Ultralisk]         = 0;
			build_order[i][BuildOrderType::ChitinousPlating]  = 0;
			build_order[i][BuildOrderType::AnabolicSynthesis] = 0;
		}

		if(build_order[i][BuildOrderType::Spire] == 0){
			build_order[i][BuildOrderType::Mutalisk] = 0;
		}

		if(build_order[i][BuildOrderType::QueensNest] == 0){
			build_order[i][BuildOrderType::Queen] = 0;
		}

		if(build_order[i][BuildOrderType::Mutalisk] == 0 || build_order[i][BuildOrderType::Spire] == 0){
			build_order[i][BuildOrderType::Scourge] = 0;
		}

		if(build_order[i][BuildOrderType::Mutalisk] == 0 || build_order[i][BuildOrderType::GreaterSpire] == 0){
			build_order[i][BuildOrderType::Devourer] = 0;
		}

		if(build_order[i][BuildOrderType::Mutalisk] == 0 || build_order[i][BuildOrderType::GreaterSpire] == 0){
			build_order[i][BuildOrderType::Guardian] = 0;
		}

		if(build_order[i][BuildOrderType::Base] - build_order[i-1][BuildOrderType::Base] > 0){ //Base^C~OHatcheryȂ΂ȂȂ
			int incremental = build_order[i][BuildOrderType::Base] - build_order[i-1][BuildOrderType::Base];
			if(build_order[i][BuildOrderType::Hatchery] - build_order[i-1][BuildOrderType::Hatchery] < incremental) build_order[i][BuildOrderType::Hatchery] = build_order[i-1][BuildOrderType::Hatchery] + (build_order[i][BuildOrderType::Base] - build_order[i-1][BuildOrderType::Base]);
		}

		int supplytotal = build_order[i][BuildOrderType::Hatchery] * 2 + build_order[i][BuildOrderType::Overload] * 16;
		int supplyused  = build_order[i][BuildOrderType::Zergling]  * 1
			            + build_order[i][BuildOrderType::Hydralisk] * 2
						+ build_order[i][BuildOrderType::Defiler]   * 4
						+ build_order[i][BuildOrderType::Lurker]    * 4
						+ build_order[i][BuildOrderType::Ultralisk] * 8
						+ build_order[i][BuildOrderType::Devourer]  * 4
						+ build_order[i][BuildOrderType::Guardian]  * 4
						+ build_order[i][BuildOrderType::Mutalisk]  * 4
						+ build_order[i][BuildOrderType::Queen]     * 4
						+ build_order[i][BuildOrderType::Scourge]   * 1
						+ i * 2;
		if(supplytotal - supplyused <= 0){
			build_order[i][BuildOrderType::Overload] = supplyused / 16 + 1;
		}
	}
}